// Solution: Boris Mihov

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

typedef long long llong;
const int MAXN = 2000 + 10;
const int INF  = 2e9 + 10;

int deg[MAXN];
int l[MAXN], n;
int inputC[MAXN];
int c[MAXN][MAXN];
std::vector <int> order;
std::vector <int> v[MAXN];
void dfs(int node, int p)
{
    order.push_back(node);
    for (const int &i : v[node])
    {
        if (i == p) continue;
        dfs(i, node);
    }
}

int a[MAXN];
bool vis[MAXN];
std::priority_queue <std::pair <int,int>> pq;
std::vector <std::pair <int,int>> g[MAXN];
void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = n + 1 ; j >= l[i] + 1 ; --j) c[i][j] = INF;
        for (int j = l[i] ; j >= 1 ; --j)
        {
            c[i][j] = std::min(c[i][j + 1], inputC[j]);
        }
    }

    order.push_back(0);
    for (int i = 1 ; i <= n ; ++i)
    {
        if (deg[i] == 1)
        {
            dfs(i, 0);
            break;
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= l[order[i]] ; ++j)
        {
            g[std::max(1, i - j + 1)].emplace_back(std::min(i + j, n + 1), c[i][j]);
        }
    }

    pq.emplace(0, 1);
    std::fill(a + 2, a + n + 2, INF);
    while (!pq.empty())
    {
        auto [dist, node] = pq.top();
        pq.pop();

        if (node == n + 1)
        {
            std::cout << a[node] << '\n';
            return;
        }

        if (vis[node]) continue;
        vis[node] = true;

        for (auto [to, ed] : g[node])
        {
            if (a[to] > a[node] + ed)
            {
                a[to] = a[node] + ed;
                pq.emplace(-a[to], to);
            }
        }
    }

    std::cout << -1 << '\n';
}

void read()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i) std::cin >> inputC[i];
    for (int i = 1 ; i <= n ; ++i) std::cin >> l[i];
    for (int i = 2 ; i <= n ; ++i)
    {
        int x, y;
        std::cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
        deg[x]++;
        deg[y]++;
    }
    
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}