#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 2000 + 10;
const int INF  = 2e9;

int cnt;
bool bl[MAXN];
int n, l[MAXN], c[MAXN], s[MAXN];
std::vector <int> g[MAXN];

void dfs(int node, int p, int left)
{
    if (left == 0) return;
    cnt += !bl[node];
    bl[node] = true;

    for (const int &i : g[node])
    {
        if (i == p) continue;
        dfs(i, node, left - 1);
    }
}

int brute(int node)
{
    if (node == n + 1)
    {
        cnt = 0;
        std::fill(bl + 1, bl + 1 + n, false);
        for (int i = 1 ; i <= n ; ++i)
        {
            dfs(i, 0, s[i]);
        }

        if (cnt == n) return 0;
        return INF;
    }

    int ans = INF;
    for (int i = 0 ; i <= l[node] ; ++i)
    {
        s[node] = i;
        ans = std::min(ans, c[i] + brute(node + 1));
    }

    if (node == 1 && ans == INF) ans = -1;
    return ans;
}

void solve()
{
    std::cout << brute(1) << '\n';
}

void read()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i) std::cin >> c[i];
    for (int i = 1 ; i <= n ; ++i) std::cin >> l[i];
    for (int i = 2 ; i <= n ; ++i)
    {
        int x, y;
        std::cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}