// Solution: Boris Mihov

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 2000 + 10;
const int INF  = 2e9 + 10;

int deg[MAXN];
int l[MAXN], n;
int inputC[MAXN];
int c[MAXN][MAXN];
llong dp[MAXN][MAXN];
bool bl[MAXN][MAXN];
std::vector <int> order;
std::vector <int> g[MAXN];
void dfs(int node, int p)
{
    order.push_back(node);
    for (const int &i : g[node])
    {
        if (i == p) continue;
        dfs(i, node);
    }
}

llong f(int node, int coveredTo)
{
    if (coveredTo >= (int)order.size() - 1) return 0;
    if (node >= order.size()) return INF;
    if (coveredTo == -1) return INF;
    if (bl[node][coveredTo])
    {
        return dp[node][coveredTo];
    }
    
    bl[node][coveredTo] = true;
    int diff = node - coveredTo;
    dp[node][coveredTo] = f(node + 1, coveredTo);
    for (int add = std::max(1, diff) ; c[order[node]][add] != INF ; ++add) 
    {
        dp[node][coveredTo] = std::min(dp[node][coveredTo], f(node + 1, node + add - 1) + c[order[node]][add]);
    }

    return  dp[node][coveredTo];
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = n + 1 ; j >= l[i] + 1 ; --j) c[i][j] = INF;
        for (int j = l[i] ; j >= 1 ; --j)
        {
            c[i][j] = std::min(c[i][j + 1], inputC[j]);
        }
    }

    order.push_back(0);
    for (int i = 1 ; i <= n ; ++i)
    {
        if (deg[i] == 1)
        {
            dfs(i, 0);
            break;
        }
    }

    int res = f(1, 0);
    if (res == INF) std::cout << -1 << '\n';
    else std::cout << res << '\n';
}

void read()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i) std::cin >> inputC[i];
    for (int i = 1 ; i <= n ; ++i) std::cin >> l[i];
    for (int i = 2 ; i <= n ; ++i)
    {
        int x, y;
        std::cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
        deg[x]++;
        deg[y]++;
    }
    
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}