#include <algorithm>
#include <iostream>
#include <fstream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 2000 + 10;
const int INF  = 2e9;

int n;
int c[MAXN];
int l[MAXN];
bool isStick;
int perm[MAXN];
std::pair <int,int> edge[MAXN];
void buildTree()
{
    std::iota(perm + 1, perm + 1 + n, 1);
    std::random_shuffle(perm + 1, perm + 1 + n);

    if (isStick)
    {
        for (llong i = 1 ; i <= n - 1 ; ++i)
        {
            edge[i] = {perm[i], perm[i + 1]};
        }
    } else
    {
        for (llong i = 2 ; i <= n ; ++i)
        {
            llong curr = rand()%(i-1) + 1;
            edge[i - 1] = {perm[i], perm[curr]};
        }
    }

    for (int i = 1 ; i <= n ; ++i) c[i] = 1e6;
    for (int i = 1 ; i <= n ; ++i) l[i] = 1;
}

void printTest(std::string filename)
{
    std::random_shuffle(edge + 1, edge + n);
    std::ofstream fout(filename);

    fout << n << '\n';
    for (llong i = 1 ; i <= n ; ++i)
    {
        fout << c[i];
        if (i != n) fout << ' ';
    }

    fout << '\n';

    for (llong i = 1 ; i <= n ; ++i)
    {
        fout << l[i];
        if (i != n) fout << ' ';
    }

    fout << '\n';
    for (llong i = 1 ; i <= n - 1 ; ++i)
    {
        if (rand()%2 == 0) std::swap(edge[i].first, edge[i].second);
        fout << edge[i].first << ' ' << edge[i].second << '\n';
    }

    fout.close();
}

int main(int argc, char **argv)
{
    n = atoi(argv[2]);
    isStick = atoi(argv[3]);

    std::ios_base :: sync_with_stdio(0);
    srand(time(nullptr));
    buildTree();
    printTest(argv[1]);    

    return 0;
}